import { store, base_context } from 'https://unpkg.com/@startinblox/core@0.9/dist/libs/store/store.js';
const sibAuth = document.querySelector('sib-auth');

//We create a custom element
class CoopStarterLoginComponent extends HTMLElement {
// Those function will be call the element is connected to the dom
  async connectedCallback() {
    document.getElementById("mentor_login").onclick = () => this.triggerLogin();
    this.update();
  }

  async triggerLogin() {
    let loader = document.getElementById('main-loader');
    loader.removeAttribute('hidden');
    await sibAuth.login();
  }
  
  async update() {
    let loader = document.getElementById('main-loader');
    loader.removeAttribute('hidden');
    let user = await sibAuth.getUser();

    //Set a userprefix default status
    var userPrefix = "public"
    
    // Idenfify the space we should go
    if (user) {
      await store.initGraph(user['@id'], base_context);
      user = await store.get(user['@id']);
 
      //If the user is a mentor or an entreprenur, change user prefix
      if(await user.mentor_profile) {
          userPrefix = "mentor"
      } else if (await user.entrepreneur_profile) {
          userPrefix = "entrepreneur"
      }
    }

    //If the url asked pointed to a resource
    if (window.location.href.indexOf('resource-detail') > -1) {
      console.log(" the link contains ressource detail")
      console.log("the current link is ", window.location.href)
      //We adapt the url with its status
      console.log("userPrefix", userPrefix)
      var newUrl = window.location.href.replace(/\/([a-z]+)-dashboard\/([a-z]+)-resource-detail/, `/${userPrefix}-dashboard/${userPrefix}-resource-detail`)
     // http://localhost:9000/fr/mentor-dashboard/@https~@~_~_api-staging~!coopstarter~!happy-dev~!fr~_resources~_7~_/mentor-resource-detail/@https~@~_~_api-staging~!coopstarter~!happy-dev~!fr~_resources~_7~_
      console.log("After treatement, the link is ", newUrl)

      //If the url is different after the treatment, we reload with the good url
      if(newUrl !== window.location.href){
        console.log("the url are different, we reload")
        
        var newRoute = new URL(newUrl).pathname.replace(/^\/([a-z]{2})\//, "")
        // console.log(newRoute);
        console.log('route:', newRoute.match(/^[^@]+/)[0]);
        console.log('resource:', newRoute.split(/@(.+)/)[1]);
        window.dispatchEvent(
          new CustomEvent('requestNavigation', { 
            detail: {
              route: newRoute.match(/^[^@]+/)[0],
              resource: newRoute.split(/@(.+)/)[1]
            }
          })
        );
        console.log("newRoute", newRoute)
        // window.location.href = newUrl

      } else {
        console.log("the url identique, let it go")
        loader.toggleAttribute('hidden', true);
      }
    } else {
      //User is a mentor
      if (userPrefix === "mentor") {
        window.dispatchEvent(
            new CustomEvent('requestNavigation', { detail: { route: 'mentor-dashboard' } })
          );
      //User is a entrepreneur
      } else if (userPrefix === "entrepreneur") {
        window.dispatchEvent(
          new CustomEvent('requestNavigation', { detail: { route: 'entrepreneur-dashboard' } })
        );
      } else if(user) {
        window.dispatchEvent(
          new CustomEvent('requestNavigation', { detail: { route: 'account-creation' } })
        );
      }
    }
  }
  empty(){}
  populate(){}
}
customElements.define('cs-login', CoopStarterLoginComponent);